<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.2.0-14                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2012-01-17 11:01:49 Manuel Olvera molvera@palosanto.com Exp $ */
//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php"; 

function _moduleContent(&$smarty, $module_name)
{
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoSetup.class.php";
    include_once "libs/paloSantoNetwork.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);
   

    include_once "modules/$module_name/libs/forms/setupForm.class.php";
    include_once "modules/$module_name/libs/parseFile.class.php";

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    $smarty->assign('module_name',$module_name);
     $arrConf['elastix_dsn']['ems'] = "sqlite3:///$arrConf[elastix_dbdir]/ems.db";
    //conexion resource
    $pDB = new paloDB($arrConf['elastix_dsn']['settings']);
    $pDB2 = new paloDB($arrConf['elastix_dsn']['ems']);
    //actions
    $action = getAction();
    $content = "";
    $result = FALSE;

    switch($action){
        case 'up_service':
        case 'down_service':
            $result = updateService($smarty, $pDB, $arrConf);break;
        case 'save_edit_server':
            $content = save($smarty, $module_name, $local_templates_dir, $pDB2, $arrConf, $result);break;
        case 'save_serial':
            $content = save($smarty, $module_name, $local_templates_dir, $pDB2, $arrConf, $result, "serial"); break;
        case 'get_trial_code':
            $content = getTrialCode($smarty, $module_name, $local_templates_dir, $pDB2, $arrConf, $result); break;
	case 'resendEmail':
	    $content = resendEmail($arrConf);
	    break;
    }
    $content = viewFormSetup($smarty, $module_name, $local_templates_dir, $pDB, $pDB2, $arrConf, $result);
    return $content;
}

function save($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $result,$mode=NULL){
    define ('WSDL_REGISTRO', $arrConf['wsdl_registro']);
    $conf_path_file = $arrConf['collectd_conf_path'];
    $pSetup = new paloSantoSetup($pDB, $conf_path_file);
    $oForm = new paloForm($smarty,createFieldFormServer());
    $message = "";


    if(!$oForm->validateForm($_POST)){
        $smarty->assign("mb_title", _tr("Validation Error"));
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>"._tr('The following fields contain errors').":</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v)
                $strErrorMsg .= "{$k}[{$v['mensaje']}], ";
        }
        $smarty->assign("mb_message", $strErrorMsg);
    }
  
    else{
        $arrSetup = array();
        $arrInfo =array();
        $success = TRUE;
        
        switch ($mode) {
             
            case 'serial':    
                          $arrInfo = getInfoSystem();
                          $arrSetup['server_name'] = "Server (".$pSetup->getServerKeyFromFile().")";
                          $arrSetup['timezone'] = $arrInfo['timezone'];
                          $arrSetup['cpu'] = matchValues(setArrData($arrInfo['cpu']));
                          $arrSetup['network'] = matchValues(setArrData($arrInfo['network']));
                          $arrSetup['disk'] = matchValues(setArrData($arrInfo['disk']));
                          $arrSetup['code']=getParameter("activation_serial");
                          if(empty($arrInfo)) $success = FALSE;   
                          $pSetup->startService();  
                          break;     
            case NULL:
                         $arrSetup['server_name'] = getParameter('name');
                         $arrSetup['code']   = getParameter('subscription');
                         if(getParameter('settings_active')=="on"){
                            $arrSetup['timezone'] = getParameter('location_timezone');
                            $arrSetup['network']=matchValues(getParameter('network'));
                            $arrSetup['cpu'] = matchValues(getParameter('cpus'));
                            $arrSetup['disk'] = matchValues(getParameter('disk'));
                         }else {
                             $arrSetup['network']=$arrSetup['cpu']=$arrSetup['disk']=null;
                             $arrSetup['timezone'] = getDefaultTimeZone();
                         }
                         break;
        }
        if($success == TRUE){
            $pSetup->_DB->beginTransaction();
            if(!$pSetup->save($arrSetup)){
                $smarty->assign("mb_title", _tr("Error"));
                $smarty->assign("mb_message", $pSetup->errMsg);
            }else{
                $arrData[] = $pSetup->getServerKeyFromFile();
                $arrData[] = $arrSetup['server_name'];
                $arrData[] = $arrSetup['code'];
                $arrData[] = $arrSetup['timezone'];
                $arrData[] = $arrSetup['network'];
                $arrData[] = $arrSetup['cpu'];
                $arrData[] = $arrSetup['disk'];
                try{
                    $oSoapClient = new SoapClient(WSDL_REGISTRO, array('exceptions' => TRUE));
                    $result = $oSoapClient->saveInfo_ServerFeatures($arrData);

                    $rs = explode('|',$result);
                    if($result!=1&&$rs[0]!='OK'){
                        $pSetup->_DB->rollBack();
                        $smarty->assign("mb_title", _tr("Error"));
                        $smarty->assign("mb_message", _tr($result));
                    }else{
			$smarty->assign("mb_title", _tr("Message"));
                        $smarty->assign("mb_message", _tr("Your data was successfully saved"));
                        $pSetup->_DB->commit();
                    }
                }
                catch(Exception $e){
                    array(
                        'FALSE',
                        "Could not retrieve activation key. Please contact site administrator.",
                    );
                    $smarty->assign("mb_title", _tr("Error"));
                    $smarty->assign("mb_message", $e->getMessage());
                    $pSetup->_DB->rollBack();
                }
            }
        }else{
            $smarty->assign("mb_title", _tr("Error"));
            $smarty->assign("mb_message", _tr("Error getting Info System"));
        }
    }
}

function setArrData($arr){
    $temp = array();
    foreach ($arr as $key => $value) {
        $temp[] = $key;
    }
    return $temp;
}

function matchValues($values){

    $result="";
    foreach ($values as $key => $value) {
        $result .= ($key==0)?$value:"|".$value; 
    }
    return $result;
}

function resendEmail($arrConf)
{
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    header('Content-type: application/json');
    include_once "$base_dir/modules/registration/libs/paloSantoRegistration.class.php";
    include_once 'libs/paloSantoJSON.class.php';
    $json = new PaloSantoJSON();
    $pRegistration = new paloSantoRegistration(new paloDB($arrConf['dsn_conn_database']),$arrConf['wsdl_registro']);
    $username = $pRegistration->getUsername();
    if(empty($username)){
	$json->set_message(array(
            'msg' => _tr("Your username account can not be found. Please try registering your server again."),
            'status' => "Error",
        ));
	print $json->createJSON();
	exit(0);
    }
    $oSoapClient = new SoapClient($arrConf['wsdl_registro'], array('exceptions' => TRUE, 'cache_wsdl' => WSDL_CACHE_NONE));
    $result = $oSoapClient->sendActivationEmail($username);

    $rs = explode("|",$result);
    if($rs[0] != "OK"){
	$json->set_message(array(
            'msg' => $rs[1],
            'status' => "Error",
        ));
        print $json->createJSON();
        exit(0);
    }
    else{
	$json->set_message(array(
            'msg' => "<font color='black'>".$rs[1]."</font>",
            'status' => "ok",
        ));
        print $json->createJSON();
        exit(0);
    }
}

function getTrialCode($smarty, $module_name, $local_templates_dir, $pDB2, $arrConf, $result){
    define ('WSDL_REGISTRO', $arrConf['wsdl_registro']);
    $conf_path_file = $arrConf['collectd_conf_path'];
    $pSetup = new paloSantoSetup($pDB2, $conf_path_file);
    $arrSetup = array();$arrInfo =array();
    $arrInfo = getInfoSystem();
 
    $arrData[] = $pSetup->getServerKeyFromFile();
    $arrData[] = "Server (".$pSetup->getServerKeyFromFile().")";//$arrSetup['server_name'];
    $arrData[] = 'is-free-trial';
    $arrData[] = $arrInfo['timezone'];
    $arrData[] = matchValues(setArrData($arrInfo['network']));
    $arrData[] = matchValues(setArrData($arrInfo['cpu']));
    $arrData[] = matchValues(setArrData($arrInfo['disk']));
    $oSoapClient = new SoapClient(WSDL_REGISTRO, array('exceptions' => TRUE));
    $result = $oSoapClient->saveInfo_ServerFeatures($arrData);

    $rs = explode('|',$result); 
    
    include_once 'libs/paloSantoJSON.class.php';
    $json = new PaloSantoJSON();

    if( $rs[0]!='OK'){
	$base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
        include_once "$base_dir/modules/registration/libs/paloSantoRegistration.class.php";
	$pRegistration = new paloSantoRegistration(new paloDB($arrConf['dsn_conn_database']),$arrConf['wsdl_registro']);
	$username = $pRegistration->getUsername();
	if(empty($username)){
	     $mess = "<br /><br />"._tr("Your username account can not be found. Please try registering your server again.");
	}
	else
	     $mess = "<br /><br /><font color='black'>"._tr("If you are having problems finding the email, click <a href='#' style='color:blue;text-decoration:underline;' onclick='resendEmail();'>HERE</a> to have it be resent.")."</font>";
        $json->set_message(array(
            'msg' => $rs[2].$mess,
            'status' => "Error",
        ));
    }else{
        $json->set_message(array(
            'msg' => $rs[1],
            'status' => "ok",
        ));
    }

    header('Content-type: application/json');
    print $json->createJSON();
     exit(0);
}

function updateService($smarty, &$pDB, $arrConf){
    $bRunning = FALSE;
    $bExito = TRUE;
    $errMsg = '';
    $conf_path_file = $arrConf['collectd_conf_path'];
    if(!file_exists($conf_path_file)){
        if(array_key_exists('HTTP_X_REQUESTED_WITH', $_SERVER)){//solicitud por ajax
            include_once 'libs/paloSantoJSON.class.php';
            $json = new PaloSantoJSON();
            $json->set_message(array(
                'button' => _tr(setupForm::$buttons['nf']),
                'status' => setupForm::$texts['nf'],
                'class'  => setupForm::$class_html['nf'],
            ));
            header('Content-type: application/json');
            print $json->createJSON();
            exit(0);
        }else
            return FALSE;
    }

    $pSetup = new paloSantoSetup($pDB, $conf_path_file);
    $bRunning = $pSetup->isRunningService();

    $action = getParameter('action');

    if($bRunning && 'down'== $action && !$pSetup->stopService()){//Si no hay problemas y si estando arriba el servicio se desea detener..
        $bExito = FALSE;
        $errMsg = $pSetup->errMsg;
    }if(!$bRunning && 'up'== $action && !$pSetup->startService()){//Si no hay problemas y si estando abajo el servicio se desea inciar..
        $bExito = FALSE;
        $errMsg = $pSetup->errMsg;
    }

    if(array_key_exists('HTTP_X_REQUESTED_WITH', $_SERVER)){//solicitud por ajax
        include_once 'libs/paloSantoJSON.class.php';
        $json = new PaloSantoJSON();

        if($bExito){
            $json->set_message(array(
                'button' => _tr($bRunning?setupForm::$buttons['nr']:setupForm::$buttons['r']),
                'status' => $bRunning?setupForm::$texts['nr'] : setupForm::$texts['r'],
                'class'  => setupForm::$class_html['nr'],
            ));
        }else{
            $json->set_status('ERROR');
            $json->set_error($errMsg);
        }

        header('Content-type: application/json');
        print $json->createJSON();
        exit(0);
    }

    if(!$bExito){
        $smarty->assign("mb_title", _tr("Error"));
        $smarty->assign("mb_message", $errMsg);
    }else{
        $smarty->assign("mb_title", _tr("Great"));
        $smarty->assign("mb_message", _tr('Last changes was done successfully'));
    }
    return $bExito;
}

/**
 *
 * @param Smarty $smarty
 * @param string $module_name
 * @param string $local_templates_dir
 * @param paloDB $pDB
 * @param array $arrConf
 * @return string
 */
function viewFormSetup($smarty, $module_name, $local_templates_dir, &$pDB, &$pDB2, $arrConf, $update_service = FALSE)
{
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    include_once "$base_dir/modules/registration/libs/paloSantoRegistration.class.php";
    $conf_path_file = $arrConf['collectd_conf_path'];
 
    $arrFill=$_POST;

    $oForm = new setupForm($smarty);
    $pSetup = new paloSantoSetup($pDB, $conf_path_file);
    $oForm->setEditMode();
    
    $bExito = TRUE;
    $bInstalled = file_exists($arrConf['collectd_conf_path']);
    $bRegistred = FALSE;
    $bUpdateKey = FALSE;
    $bRunning = $pSetup->isRunningService();
    $register = FALSE;
    $_DATA  = array();

    $oForm->reallyHasServerKey();
    $pRegistration = new paloSantoRegistration(new paloDB($arrConf['dsn_conn_database']),$arrConf['wsdl_registro']);
    if($bInstalled){
        try{
            $oKeyFile = new parseFile($arrConf['elastix_key_server'], parseFile::NO_PARSE);
            if($oKeyFile->offsetExists(0)){
                $_DATA['server_key'] = trim($oKeyFile[0]);//Obtengo el server key del archivo
                $bRegistred = !empty($_DATA['server_key']);
                //Si existe dejar el formulario sin opción de edición del valor del campo
                if($bRegistred){
                    $register = TRUE;
                    $serverkey=$pSetup->getServerKeyFromFile();
                    if($serverkey===false){
                        $smarty->assign("mb_title", _tr("Error"));
                        $smarty->assign("mb_message", _tr("Couldn't be retrieved info from /etc/collectd.conf file. ").$pSetup->errMsg);
                    }else{
                        if($_DATA['server_key']!=$serverkey){
                            $bUpdateKey=true;
                            $exito=$pSetup->saveServerKeyOnFile($_DATA['server_key']);
                            if($exito===false){
                                $smarty->assign("mb_title", _tr("Error"));
                                $smarty->assign("mb_message", _tr("Couldn't be established serverkey in  /etc/collectd.conf file. ").$pSetup->errMsg);
                            }
                        }
                    }
                }
            }
            unset($oKeyFile);
        }catch(InvalidArgumentException $e){
            
        }//File not found
    }else{
        $_DATA['enable'] = 'off';
        $oForm->serviceNotEnable();
    }

    if(!$bInstalled){
        $smarty->assign("mb_title", _tr("Installer error"));
        $smarty->assign("mb_message", _tr('Monitoring service was not detected'));
    }else{
        if(!$register){
            $oForm->noRegister();
            $_DATA['server_key']="?";

            $smarty->assign("IS_REGISTERED",$_DATA['server_key']);

           //if service is running then stop service
            if($bRunning){
                $pSetup->stopService();
            }
        }else{
            if($bUpdateKey){
                if($bRunning){
                    $pSetup->stopService();
                }
            }else{
        if($bRunning){
                $oForm->isRunning();
            }
            }
        }
    }
    $smarty->assign("CHECK_APP_LABEL",_tr("Is a Elastix Appliance"));

    //comprobamos en caso de que el servidor haya sido marcado como un elastix appliance
    $is_app_elx=getParameter("is_app_elx");
    if($is_app_elx=="on"){
        $smarty->assign("IS_APP_ELASTIX","checked");
    }else{
        $smarty->assign("IS_APP_ELASTIX","");
    }

    $arrForm = createFieldFormServer();
    $serverForm = new paloForm($smarty,$arrForm);

    if(getParameter('edit_server')) $serverForm->setEditMode();
    else $serverForm->setViewMode();    

    $pSetupConf = new paloSantoSetup($pDB2, $conf_path_file);

    $arrFill = $pSetupConf->getSetup();

    if($arrFill['settings_active']!="on")  $smarty->assign("empty", 1);

    $smarty->assign("REQUIRED_FIELD", _tr("Required field"));
    $smarty->assign("CANCEL", _tr("Cancel"));
    $smarty->assign("APPLY_CHANGES", _tr("Apply changes"));
    $smarty->assign("SAVE", _tr("Save"));
    $smarty->assign("EDITSERVER", _tr("Edit"));
    $smarty->assign("DELETE", _tr("Delete"));
    $smarty->assign("CONFIRM_CONTINUE", _tr("Are you sure you wish to continue?"));
    $smarty->assign("MODULE_NAME",$module_name);
    $smarty->assign("NETWORK",_tr('Network'));
    $smarty->assign("DISK",_tr('Hard Dirve'));
    $smarty->assign("NEW_SUBSCRIPTION",_tr("New Subscription"));
    $smarty->assign("SERVER_KEY_LABEL",_tr("Elastix Server Key"));
    $smarty->assign("ADVANCED_SETTINGS",_tr("Advanced Settings"));
    $smarty->assign('icon', "modules/$module_name/images/elastix-monitoring_services.jpeg");
    $smarty->assign("server_key",$_DATA['server_key']);
    $smarty->assign("SERVICE_MONITOR",_tr("Service Monitoring Status"));
    $smarty->assign("ELASTIX_MONITORING_SERVICES",_tr("Elastix Monitoring Services"));
    $smarty->assign("LABEL_ERROR_REGISTER",_tr("In order to use this service you must register you server first"));
    $smarty->assign("LINK_REGISTER",_tr("Click Here to Register"));
    $smarty->assign("ELX_CLOUD",_tr("Click Here to Access to Elastix Cloud"));
    $smarty->assign("ELX_CLOUD_TO",_tr("To monitor your server in real time"));
    $smarty->assign("DEFAULT_TIMEZONE",getDefaultTimeZone());
   

    if($pRegistration->getLinkAutoLogin()=='')
        $smarty->assign("serial_monitor","user=".$pRegistration->getUsername());
    else
        $smarty->assign("serial_monitor","c=".$pRegistration->getLinkAutoLogin());
      
    if(is_array($pSetupConf->getSetup())){
        $content = $oForm->fetchForm("$local_templates_dir/form_setup.tpl",_tr("Setup"), $_DATA);
        $htmlForm = $serverForm->fetchForm("$local_templates_dir/form_setup.tpl",_tr("Service Monitoring Setup"), $arrFill);
        $content = "<form  method='POST' enctype='multipart/form-data' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";
    }else{
        $content = viewFormIntro($smarty,$module_name,$local_templates_dir,$pDB2,$arrConf);
    }
    
    return $content;
  
}

function viewFormIntro($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    include_once "$base_dir/modules/registration/libs/paloSantoRegistration.class.php";
    $pRegistration = new paloSantoRegistration(new paloDB($arrConf['dsn_conn_database']),$arrConf['wsdl_registro']);
    $serverkey = $pRegistration->isRegistered();

    $oForm =  new paloForm($smarty,array());

    $smarty->assign("action_validation", "document.forms[0].submit();");

    $smarty->assign("UPLOAD", _tr("Upload License"));
    $smarty->assign("MODULE_NAME", $module_name);
    $smarty->assign('ccpro_title', _tr("About us"));
    $smarty->assign("WELCOME_MONITORING",_tr("WELCOME_MONITORING"));
    $smarty->assign("CONTENT_ABOUT1",_tr("CONTENT_ABOUT1"));
    $smarty->assign("CONTENT_ABOUT2",_tr("CONTENT_ABOUT2"));
    $smarty->assign("CONTENT_ABOUT3",_tr("CONTENT_ABOUT3"));
    $smarty->assign("input_text",_tr("Type your serial key"));
    $smarty->assign("ACTIVATION_SERIAL",_tr("SERIAL KEY"));
    $smarty->assign("PAID_VERSION",_tr("Paid Version"));
    $smarty->assign("TRIAL_BUTTON",_tr("Get Trial"));
    $smarty->assign("ACTIVE_BUTTON",_tr("Activate"));
    $smarty->assign("LOADING_BUTTON",_tr("Getting Serial Key..."));
    
    $smarty->assign("DAYS",_tr("Days"));
    $smarty->assign("LABEL_ERROR_REGISTER",_tr("In order to use this service you must register you server first"));
    $smarty->assign("LINK_REGISTER",_tr("Click Here to Register"));
    $smarty->assign("FORM_LINK",_tr("OBTAIN YOUR LICENSE KEY BY CONTACTING US"));
    $smarty->assign("COPYRIGHT","&copy; ".date("Y")." "._tr("Elastix. All rights reserved"));
    $htmlForm = $oForm->fetchForm("$local_templates_dir/form_intro.tpl",_tr("Configuration"));
    $content = "<form  method='POST' enctype='multipart/form-data' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";

    return $content;
}



function getAction()
{
    if(getParameter("save_new")) //Get parameter by POST (submit)
        return "save_new";
    else if(getParameter("save_edit_server")) //Get parameter by POST (submit)
        return "save_edit_server";
    else if(getParameter("save_edit"))
        return "save_edit";
    else if(getParameter("save_serial"))
        return "save_serial";
    else if(getParameter("delete"))
        return "delete";
    else if(getParameter("new_open"))
        return "view_form";
    else if(getParameter("action")=="view")      //Get parameter by GET (command pattern, links)
        return "view_form";
    else if(getParameter("action")=="view_edit")
        return "view_form";
    else if(getParameter("action")=="up" || !is_null(getParameter("action_nr"))){
        $_POST['action'] = 'up';
        return "up_service";
    }else if(getParameter("action")=="down" || !is_null(getParameter("action_r"))){
        $_POST['action'] = 'down';
        return "down_service";
    }else if(getParameter("action")=="get_trial_code"){
        return "get_trial_code";
    }else if(getParameter("action")=="resendEmail")
	return "resendEmail";
    else
        return "report"; //cancel
}

if(!function_exists('_tr')){
    function _tr($value){
        global $arrLang;
        if(array_key_exists($value,$arrLang))   return $arrLang[$value];
        else                                    return '';
    }
}
function getTimeZone(){
    $result=array("-12:00", "-11:00", "-10:00",  "-09:30", "-09:00", "-08:00", "-07:00", "-06:00", "-05:00", "-04:30", "-04:00",  "-03:30", "-03:00", "-02:30", "-02:00", "-01:00", "+00:00", "+01:00", "+02:00", "+03:00", "+03:30", "+04:00", "+04:30", "+05:00", "+05:30", "+06:00", "+06:30", "+07:00", "+08:00", "+08:45", "+09:00", "+09:30", "+10:00", "+10:30", "+11:00", "+11:30", "+12:00", "+12:45", "+13:00", "+13:45", "+14:00");
    return $result;
}

function getNetworkInterfaces(){
    $pNet = new paloNetwork();
    $arrEths = $pNet->obtener_interfases_red_fisicas();

    $interfaces = array();
    foreach($arrEths as $idEth=>$arrEth) {
            $interfaces[$idEth] = $arrEth['Name'];
    }
    return $interfaces;
}

function getProccessors()
{
    exec("cat /proc/cpuinfo | grep processor",$arrOutput,$flatStatus);
    $arrProccessors = array();

    if($flatStatus==0){
        if(is_array($arrOutput) && count($arrOutput)>0){
            foreach($arrOutput as $k => $line){
                if(preg_match("/^processor\s+:\s+([0-9]+)/",$line,$arrTokens)){
                    $arrProccessors["cpu".$arrTokens[1]] = "CPU {$arrTokens[1]}";
                }
            }
        }
    }
    return $arrProccessors;
}

function getMountedPartitions() {
    $arrOutput  = null;
    $flatStatus = null;
    exec("/bin/df -hP",$arrOutput,$flatStatus);

    $arrParticions = array();
    if($flatStatus==0){
        if(is_array($arrOutput) && count($arrOutput)>0){
            foreach($arrOutput as $k => $line){
                if($k> 0 && preg_match("/^(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/",$line,$arrTokens)){
                    if(substr($arrTokens[1],0,4) != "/dev") continue;

                    if(substr($arrTokens[1],0,11) == "/dev/mapper"){
                        $arrOutput2  = null;
                        $flatStatus2 = null;
                        exec("/bin/ls -l {$arrTokens[1]} | grep '../dm-'",$arrOutput2,$flatStatus2);

                        if($flatStatus2==0){
                            if(is_array($arrOutput2) && count($arrOutput2)==1){ //solo una linea debe ser
                                $arrDM = explode("../",$arrOutput2[0]);
                                $arrParticions[trim($arrDM[1])] = "{$arrTokens[1]} ({$arrTokens[6]} - {$arrTokens[5]})";
                            }
                        }
                    }
                    else{
                        $arrParticions[basename($arrTokens[1])] = "{$arrTokens[1]} ({$arrTokens[6]} - {$arrTokens[5]})";
                    }
                }
            }
        }
    }
    return $arrParticions;
}

function getRPMVersion($rpm){

    $packageLists = array($rpm);
    $sCommand = 'rpm -qa  --queryformat "%{name} %{version} %{release}\n"';
    if (is_array($packageLists)) $sCommand .= ' '.implode(' ', array_map('escapeshellarg', $packageLists));
    $output = $retval = NULL;
    exec($sCommand, $output, $retval);

    if(is_array($output)){
        foreach ($output as $s) {
            $fields = explode(' ', $s);
            $packageVersions[$fields[0]] = $fields;
        }
        //0: name | 1: version | 2: release
        return $packageVersions[$rpm];
    }
    return null;
    
}

function getDefaultTimeZone(){
     $sCommand = 'date +%:z';
     $output = $retval = NULL;
     exec($sCommand, $output, $retval);
     if(is_array($output))
        return $output[0];
     else
        return null;
}

function getInfoSystem(){
    $arrData = array();
    $arrData['cpu']     = getProccessors();
    $arrData['timezone']= getDefaultTimeZone();
    $arrData['network'] = getNetworkInterfaces();
    $arrData['disk']    = getMountedPartitions();

    foreach ($arrData as $key => $value) {
        if(empty($value))
            return NULL;
    }
    return $arrData;

}


function createFieldFormServer()
{
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    include_once "$base_dir/modules/registration/configs/default.conf.php";

    $mounts = array();
    $mounts = getMountedPartitions();
    $processors = getProccessors();
    $arrTimeZone=array();

    $interfaces = getNetworkInterfaces();
   
    foreach(getTimeZone() as $value){
        $arrTimeZone[$value]="GMT$value";
    }

   
    $arrFormElements = array(
                            "name"                  => array("LABEL"         => _tr("Server Name"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "TEXT",
                                                    "INPUT_EXTRA_PARAM"      => array("style"=>"width:300px;"),
                                                    "VALIDATION_TYPE"        => "text",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "serverkey"             => array("LABEL"         => _tr("Elastix Server Key"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "TEXT",
                                                    "INPUT_EXTRA_PARAM"      => array("style"=>"width:300px;"),
                                                    "VALIDATION_TYPE"        => "text",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "location_timezone"     => array("LABEL"        => _tr("Time Zone"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "SELECT",
                                                    "INPUT_EXTRA_PARAM"      => $arrTimeZone,
                                                    "VALIDATION_TYPE"        => "text",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "model"                 => array("LABEL"         => _tr("Model"),
                                                    "REQUIRED"               => "no",
                                                    "INPUT_TYPE"             => "TEXT",
                                                    "INPUT_EXTRA_PARAM"      => "",
                                                    "VALIDATION_TYPE"        => "text",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "serial"                => array("LABEL"         => _tr("Serial"),
                                                    "REQUIRED"               => "no",
                                                    "INPUT_TYPE"             => "TEXT",
                                                    "INPUT_EXTRA_PARAM"      => "",
                                                    "VALIDATION_TYPE"        => "text",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "subscription"          => array("LABEL"         => _tr("Activation Serial Key"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "TEXT",
                                                    "INPUT_EXTRA_PARAM"      => array("style"=>"width:300px;"),
                                                    "VALIDATION_TYPE"        => "numeric",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                           
                            "network"               => array("LABEL"         => _tr("Network Interfaces"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "SELECT",
                                                    "INPUT_EXTRA_PARAM"      => $interfaces,
                                                    "VALIDATION_TYPE"        => "text",
                                                    "MULTIPLE"               => true,
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "disk"                  => array("LABEL"         => _tr("Drives mounted partitions"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "SELECT",
                                                    "INPUT_EXTRA_PARAM"      => $mounts,
                                                    "VALIDATION_TYPE"        => "",
                                                    "MULTIPLE"               => true,
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "cpus"                  => array("LABEL"         => _tr("Processor Devices"),
                                                    "REQUIRED"               => "yes",
                                                    "INPUT_TYPE"             => "SELECT",
                                                    "INPUT_EXTRA_PARAM"      => $processors,
                                                    "VALIDATION_TYPE"        => "",
                                                    "MULTIPLE"               => true,
                                                    "VALIDATION_EXTRA_PARAM" => ""),
                            "settings_active"       => array("LABEL"         => _tr("Advanced Settings"),
                                                    "REQUIRED"               => "no",
                                                    "INPUT_TYPE"             => "CHECKBOX",
                                                    "INPUT_EXTRA_PARAM"      => array("onclick"),
                                                    "VALIDATION_TYPE"        => "",
                                                    "VALIDATION_EXTRA_PARAM" => ""),
    );
    
    return $arrFormElements;
}

